using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WebsiteCapture
{
    public partial class FragmentForm : Form
    {
        public FragmentForm()
        {
            InitializeComponent();
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            errorProviderEx1.ClearAll();

            if (string.IsNullOrEmpty(txtFragmentCode.Text))
                errorProviderEx1.SetError(lblFragmentCode, LangManager.Instance.Read(LangManager.FragmentForm, "EmptyFragment"));
            if (string.IsNullOrEmpty(txtFragmentName.Text))
                errorProviderEx1.SetError(lblFragmentName, LangManager.Instance.Read(LangManager.FragmentForm, "EmptyName"));

            if (errorProviderEx1.HasErrors)
                this.DialogResult = DialogResult.None;
            else
                this.DialogResult = DialogResult.OK;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
        }

        private void pasteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            txtFragmentCode.Text = Clipboard.GetText();
        }

        private void contextMenuStrip1_Opening(object sender, CancelEventArgs e)
        {
            if (!Clipboard.ContainsText())
                e.Cancel = true;
        }

        public string FragmentCode
        {
            get 
            {
                return txtFragmentCode.Text;
            }
        }

        public string FragmentName
        {
            get { return txtFragmentName.Text; }
        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(txtFragmentCode.Text);
        }

        private void FragmentForm_Load(object sender, EventArgs e)
        {
            LangManager li = LangManager.Instance;

            this.Text             = li.Read(LangManager.FragmentForm, "Title");
            this.btnOk.ButtonText = li.Read(LangManager.Common, "Ok");
            this.btnCancel.ButtonText = li.Read(LangManager.Common, "Cancel");
            this.lblFragmentCode.Text = li.Read(LangManager.FragmentForm, "FragmentCode");
            this.lblFragmentName.Text = li.Read(LangManager.FragmentForm, "FragmentName");
        }
    }
}