using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace WebsiteCapture
{
    public enum FileMode
    {
        Local,
        Remote,
        Fragment
    }

    public class HtmlFileInfo
    {
        public string FilePath; //FilePath or URL or Html fragment content
        public FileMode FileMode = FileMode.Local;

        public HtmlFileInfo(string filePath, FileMode fileMode)
        {
            this.FilePath = filePath;
            this.FileMode = fileMode;

            switch (fileMode)
            {
                case FileMode.Local:
                    this.fileName = Path.GetFileName(filePath);
                    FileInfo fi = new FileInfo(filePath);
                    fileSize = Math.Round((double)fi.Length / 1000);

                    break;
                case FileMode.Remote:
                    this.fileName = new Uri(filePath).Host;
                    fileSize = 0;

                    break;

                case FileMode.Fragment:
                    this.fileName = "";
                    fileSize = 0;
                    break;

                default:
                    break;
            }
        }

        private string fileName;
        public string FileName
        {
            get { return fileName; }
            set { fileName = value; }
        }

        private double fileSize;
        public double FileSize
        {
            get { return fileSize; }
        }

        private string htmlContent;
        public string HtmlContent
        {
            get { return htmlContent; }
            set { htmlContent = value; }
        }

        public string GetImgFileName(OutputFormat format)
        {
            switch (FileMode)
            {
                case FileMode.Local:
                    return Path.GetFileNameWithoutExtension(this.FileName) + format.Extension;
                case FileMode.Remote:
                    return this.FileName.Replace('.', '_') + format.Extension;
                case FileMode.Fragment:
                    return this.fileName + format.Extension;
                default:
                    return "";
            }
        }
    }
}
