using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace WebsiteCapture
{
    public class ListViewHelper
    {
        public static ListViewColumnSorter lvwColumnSorter = new ListViewColumnSorter();

        public static void SortListView(object sender, ColumnClickEventArgs e)
        {
            ListView listView = (ListView)sender;
            if (e.Column == lvwColumnSorter.SortColumn)
            {
                // Reverse the current sort direction for this column.
                if (lvwColumnSorter.Order == SortOrder.Ascending)
                    lvwColumnSorter.Order = SortOrder.Descending;
                else
                    lvwColumnSorter.Order = SortOrder.Ascending;
            }
            else
            {
                // Set the column number that is to be sorted; default to ascending.
                lvwColumnSorter.SortColumn = e.Column;
                lvwColumnSorter.Order = SortOrder.Ascending;
            }
            // Perform the sort with these new sort options.
            listView.Sort();
        }

        public static void SelectIndex(ListView view, int idx)
        {
            if (view.SelectedIndices.Count != 0)
            {
                if (view.SelectedIndices.Contains(idx))
                    return;
                view.SelectedIndices.Clear();
                view.SelectedIndices.Add(idx);
            }
            else
                view.SelectedIndices.Add(idx);
        }
    }
}
