using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace WebsiteCapture
{
    public class ListViewItemCollectionEx : ListView.ListViewItemCollection
    {
        public delegate void ItemNumberChangedHandler(ListViewItemCollectionEx owner, int num);
        public event ItemNumberChangedHandler ItemNumberChanged;

        public ListViewItemCollectionEx(ListView owner)
            : base(owner)
        {
        }

        public override ListViewItem Add(ListViewItem value)
        {
            ListViewItem item = base.Add(value);
            if (ItemNumberChanged != null)
                ItemNumberChanged(this, this.Count);
            return item;
        }

        public override ListViewItem Add(string key, string text, int imageIndex)
        {
            ListViewItem item = base.Add(key, text, imageIndex);
            if (ItemNumberChanged != null)
                ItemNumberChanged(this, this.Count);
            return item;
        }

        public override ListViewItem Add(string key, string text, string imageKey)
        {
            ListViewItem item = base.Add(key, text, imageKey);
            if (ItemNumberChanged != null)
                ItemNumberChanged(this, this.Count);
            return item;
        }

        public override ListViewItem Add(string text)
        {
            ListViewItem item = base.Add(text);
            if (ItemNumberChanged != null)
                ItemNumberChanged(this, this.Count);
            return item;
        }

        public override ListViewItem Add(string text, int imageIndex)
        {
            ListViewItem item = base.Add(text, imageIndex);
            if (ItemNumberChanged != null)
                ItemNumberChanged(this, this.Count);
            return item;
        }

        public override ListViewItem Add(string text, string imageKey)
        {
            ListViewItem item = base.Add(text, imageKey);
            if (ItemNumberChanged != null)
                ItemNumberChanged(this, this.Count);
            return item;
        }

        public override void Clear()
        {
            base.Clear();
            if (ItemNumberChanged != null)
                ItemNumberChanged(this, this.Count);
        }

        public override ListViewItem Insert(int index, string key, string text, int imageIndex)
        {
            ListViewItem item = base.Insert(index, key, text, imageIndex);
            if (ItemNumberChanged != null)
                ItemNumberChanged(this, this.Count);
            return item;
        }

        public override ListViewItem Insert(int index, string key, string text, string imageKey)
        {
            ListViewItem item = base.Insert(index, key, text, imageKey);
            if (ItemNumberChanged != null)
                ItemNumberChanged(this, this.Count);
            return item;
        }

        public override void Remove(ListViewItem item)
        {
            base.Remove(item);
            if (ItemNumberChanged != null)
                ItemNumberChanged(this, this.Count);
        }

        public override void RemoveAt(int index)
        {
            base.RemoveAt(index);
            if (ItemNumberChanged != null)
                ItemNumberChanged(this, this.Count);
        }

        public override void RemoveByKey(string key)
        {
            base.RemoveByKey(key);
            if (ItemNumberChanged != null)
                ItemNumberChanged(this, this.Count);
        }
    }
}
