using System;
using System.Collections.Generic;
using System.Text;

namespace WebsiteCapture
{
    public class OutputFormat
    {
        public string Name;
        public string Extension;

        public OutputFormat(string name, string ext)
        {
            this.Name = name;
            this.Extension = ext;
        }

        public override string ToString()
        {
            return this.Name;
        }

        public static List<OutputFormat> Formats
        {
            get 
            {
                List<OutputFormat> res = new List<OutputFormat>();
                res.Add(new OutputFormat("JPG File (*.jpg)", ".jpg"));
                res.Add(new OutputFormat("Bitmap File (*.bmp)", ".bmp"));
                res.Add(new OutputFormat("Png File (*.png)", ".png"));
                res.Add(new OutputFormat("Tiff File (*.tiff)", ".tiff"));
                res.Add(new OutputFormat("Targa File (*.tga)", ".tga"));
                //res.Add(new OutputFormat("Pcx File (*.pcx)", ".pcx"));
                //res.Add(new OutputFormat("Psd File (*.psd)", ".psd"));
                res.Add(new OutputFormat("Gif File (*.gif)", ".gif"));
                //res.Add(new OutputFormat("Kodak Photo-CD (*.pcd)", ".pcd"));
                return res;
            }
        }

        public static OutputFormat Parse(string name)
        {
            foreach (OutputFormat format in Formats)
            {
                if (format.Name == name)
                    return format;
            }
            return null;
        }
    }
}
