using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace WebsiteCapture
{
    public partial class URLForm : Form
    {
        public URLForm()
        {
            InitializeComponent();
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            errorProviderEx1.ClearAll();

            //Regex regex = new Regex(@"^((http|https):\/\/)*[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,5}(([0-9]{1,5})?\/.*)?$");
            //if (!regex.IsMatch(txtURL.Text))
            //{
            //    errorProviderEx1.SetError(txtURL, "Invalid URL");
            //    this.DialogResult = DialogResult.None;
            //}

            try
            {
                new Uri(this.URL);
            }
            catch 
            {
                errorProviderEx1.SetError(txtURL, LangManager.Instance.Read(LangManager.URLForm, "InvalidURL"));
                this.DialogResult = DialogResult.None;
            }
            this.DialogResult = DialogResult.OK;
        }

        public string URL
        {
            get 
            {
                string txtUri = txtURL.Text;
                if (!txtUri.StartsWith("http://"))
                    txtUri = "http://" + txtUri;
                return txtUri;
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
        }

        private void contextMenuStrip1_Opening(object sender, CancelEventArgs e)
        {
            if (!Clipboard.ContainsText())
                e.Cancel = true;
        }

        private void pasteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            txtURL.Text = Clipboard.GetText();
        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(txtURL.Text);
        }

        private void URLForm_Load(object sender, EventArgs e)
        {
            LangManager li = LangManager.Instance;
            this.Text = li.Read(LangManager.URLForm, "Title");
            this.lblURL.Text = li.Read(LangManager.URLForm, "URL");
            this.btnOk.ButtonText = li.Read(LangManager.Common, "Ok");
            this.btnCancel.ButtonText = li.Read(LangManager.Common, "Cancel");

            copyToolStripMenuItem.Text  = li.Read(LangManager.Common, "Copy");
            pasteToolStripMenuItem.Text = li.Read(LangManager.Common, "Paste");
        }
    }
}